import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class MyCanvas extends Canvas implements MouseListener, MouseMotionListener{
	Vector		vect;					// `f[^i[ꏊ
	Fig			obj;					// ݂̐}`
	String		txt;					// eLXgtB[h̃eLXg
	int			fillFlag;				//  ( 0:m[}A1:hԂA2: )
	Color		clr;					// J[
	Image		iBuf;
	Graphics	gBuf;

	MyCanvas(){									// RXgN^
		super();								// eNX̃RXgN^
		vect = new Vector(100,50);				// i[ꏊ쐬
		addMouseListener(this);					// mouseXi[쐬
		addMouseMotionListener(this);			// mouseXi[쐬
		txt = "";
		fillFlag = 0;
		clr = new Color(0,0,0);
	}
	MyCanvas(Color color){						// RXgN^
		super();								// eNX̃RXgN^
		vect = new Vector(100,50);				// i[ꏊ쐬
		addMouseListener(this);					// mouseXi[쐬
		addMouseMotionListener(this);			// mouseXi[쐬
		txt = "";
		fillFlag = 0;
		clr = color;
	}

	public void update(Graphics g){				// updateI[o[Ch
		paint(g);
	}
	public void paint(Graphics g){
		if ( iBuf == null ){
			erase(g);
			Dimension d = getSize();
			iBuf = createImage(d.width, d.height);
		}
		if ( gBuf == null ){
			gBuf = iBuf.getGraphics();
			erase(gBuf);
		}
		g.drawImage(iBuf,0,0,this);
		obj.draw(g);
	}

	private void ondraw(Graphics g){				// `
		int		i    = 0;
		int		max  = vect.size();

		for ( ; i < max ; i++ )
			((Fig)vect.elementAt(i)).draw(g);
	}

	public void mousePressed(MouseEvent me){	// }EXꂽ
		obj.setP1( me.getPoint() );				// p1Zbg
	}

	public void mouseReleased(MouseEvent me){	// }EXꂽ
		obj.setP2( me.getPoint() );				// p2Zbg
		vect.addElement(obj);					// vectorɒǉ
		itemChanged((obj.getClass()).getName());// VIuWFNg
		ondraw(gBuf);
		repaint();								// `
	}

	public void mouseDragged(MouseEvent me){	// }EXhbO
		if ( (obj.getClass()).getName().equals("MyLocus") ){
			obj.setPoint( me.getPoint() );
		}
		obj.setP2( me.getPoint() );
		repaint();
	}

	protected void itemChanged(String cmd){		// VIuWFNg

		if ( cmd.equals("") || cmd.equals("MyLine") )			obj = new MyLine(fillFlag, clr);
		else if ( cmd.equals("`") || cmd.equals("MyRect"))		obj = new MyRect(fillFlag, clr);
		else if ( cmd.equals("~") || cmd.equals("MyCircle"))		obj = new MyCircle(fillFlag, clr);
		else if ( cmd.equals("ȉ~") || cmd.equals("MyEllipse"))	obj = new MyEllipse(fillFlag, clr);
		else if ( cmd.equals("eLXg") || cmd.equals("MyText"))	obj = new MyText(fillFlag, clr, txt);
		else if ( cmd.equals("O") || cmd.equals("MyLocus"))		obj = new MyLocus(fillFlag, clr);

		else if ( cmd.equals("̂")){
			fillFlag = 0;
			obj.setFillFlag(0);
		}
		else if ( cmd.equals("hԂ")){
			fillFlag = 1;
			obj.setFillFlag(1);
		}
		else if ( cmd.equals("")){
			fillFlag = 2;
			obj.setFillFlag(2);
		}
		else
			obj = new MyLine(fillFlag, clr);
	}

	protected void undo(){						// ЂƂNA
		int i = vect.size();
		if ( i > 0 )
			vect.removeElementAt(i-1);
		erase(gBuf);
		ondraw(gBuf);
		repaint();
	}
	protected void clear(){						// ׂăNA
		vect.removeAllElements();
		erase(gBuf);
		ondraw(gBuf);
		repaint();
	}
	private void erase(Graphics g){
		Dimension d = getSize();
		g.setColor(new Color(255,255,255));
		g.fillRect(0,0,d.width,d.height);
	}
	protected boolean setString(String msg){	// TextFieldύXꂽ
		txt = msg;
		if ( (obj.getClass()).getName().equals("MyText") ){
			obj.setString(msg);
			return true;
		}
		return false;
	}

	protected void setColor(Color color){		// J[ύXꂽ
		obj.setColor(color);
		clr = color;
	}

	public void mouseClicked(MouseEvent me){}
	public void mouseExited(MouseEvent me){}
	public void mouseEntered(MouseEvent me){}
	public void mouseMoved(MouseEvent me){}
}
