import java.lang.*;
import java.awt.*;

public class MyEllipse extends Fig{
	MyEllipse(int fill, Color c){
		super(fill, c);
	}

	MyEllipse(int fill, Color c, Point pA, Point pB){
		super(fill, c);
		p1 = pA;
		p2 = pB;
	}

	public void draw(Graphics g){
		int x = Math.min( p1.x, p2.x );
		int y = Math.min( p1.y, p2.y );
		int w = Math.max( p1.x, p2.x ) - x;
		int h = Math.max( p1.y, p2.y ) - y;
		g.setColor(clr);
		if ( fillFlag == 0 ){				// m[}
			g.drawOval(x,y,w,h);
			return;
		}
		if ( fillFlag == 1){				// hԂ
			g.fillOval(x,y,w,h);
			return;
		}
		if ( fillFlag == 2 ){				// 
			g.drawOval(x-1,y-1,w  ,h  );
			g.drawOval(x-1,y-1,w+1,h+1);
			g.drawOval(x  ,y-1,w  ,h  );
			g.drawOval(x  ,y-1,w+1,h+1);
			g.drawOval(x-1,y  ,w  ,h  );
			g.drawOval(x-1,y  ,w+1,h+1);
			g.drawOval(x  ,y  ,w,  h  );
			g.drawOval(x+1,y+1,w-1,h-1);
			g.drawOval(x+1,y+1,w  ,h  );
			g.drawOval(x  ,y+1,w-1,h-1);
			g.drawOval(x  ,y+1,w  ,h  );
			g.drawOval(x+1,y  ,w-1,h-1);
			g.drawOval(x+1,y  ,w  ,h  );
			return;
		}
	}
}