import java.lang.*;
import java.awt.*;
import java.util.*;

public class MyLocus extends Fig{
	Vector p;							// e|Cg

	MyLocus(int fill, Color c){
		super(fill, c);
		p = new Vector(100,50);
	}

	MyLocus(int fill, Color c, Point pA, Point pB){
		super(fill, c);
		p = new Vector(100,50);
		p1 = pA;
		p2 = pB;
	}

	public void setPoint(Point p1){
		p.addElement(p1);
	}

	public void draw(Graphics g){
		int		i;
		int		max = p.size();
		Point	pStart;
		Point	pEnd;

		g.setColor(clr);
		if ( max <= 1 )		return;
		pEnd = (Point)p.elementAt(0);

		for ( i = 1 ; i < max ; i++ ){
			pStart = pEnd;
			pEnd   = (Point)p.elementAt(i);
			g.drawLine(pStart.x, pStart.y, pEnd.x, pEnd.y);	// m[}
			if ( fillFlag == 1 || fillFlag == 2 ){			//  or hԂ
				g.drawLine(pStart.x-1, pStart.y, pEnd.x-1, pEnd.y);
				g.drawLine(pStart.x+1, pStart.y, pEnd.x+1, pEnd.y);
				g.drawLine(pStart.x, pStart.y-1, pEnd.x, pEnd.y-1);
				g.drawLine(pStart.x, pStart.y+1, pEnd.x, pEnd.y+1);
			}
		}
	}
}