import java.lang.*;
import java.awt.*;

public class MyText extends Fig{
	String str;

	MyText(int fill, Color c){
		super(fill, c);
		str = "";
	}
	MyText(int fill, Color c, String msg){
		super(fill, c);
		str = msg;
	}

	MyText(Point pA, Point pB){
		super();
		p1  = pA;
		p2  = pB;
		str = "";
	}

	protected void setString(String msg){	// TextFieldύXꂽAύX
		str = msg;
	}

	public void draw(Graphics g){
		int		x, y;
		int		sub;
		int		fontSize = 14;
		boolean flag = true;
		Font	font;
		FontMetrics fm;

		if (str.length() <= 0 )
			return;

		if ( p1.x < p2.x ){
			x   = p1.x;
			y   = p1.y;
			sub = p2.x - x;
		}
		else{
			x   = p2.x;
			y   = p2.y;
			sub = p1.x - x;
		}

		if ( fillFlag == 0 ){				// m[}
			font = new Font("Serif", 0, fontSize);
			g.setFont(font);
		}

		else if ( fillFlag == 1){			// hԂ
			fontSize *= 2;
			font = new Font("Serif", 0, fontSize);
			g.setFont(font);
		}
		else if ( fillFlag == 2){			// 
			fontSize *= 2;
			font = new Font("Serif", Font.BOLD, fontSize);
			g.setFont(font);
		}


		g.setColor(clr);
		g.drawString(str, x, y);
	}
}